diff -u midishare.orig/midishare-test.lisp midishare/midishare-test.lisp
--- midishare.orig/midishare-test.lisp	2005-12-11 05:58:03.000000000 +0000
+++ midishare/midishare-test.lisp	2005-12-11 06:01:49.000000000 +0000
@@ -218,7 +218,7 @@
 
 (defun send-note (pitch)
   (let ((ev (MidiNewEv typeNote))) ; ask for a new note event
-    (unless (cffi:null-ptr-p ev)   ; if the allocation was succesfull
+    (unless (cffi:null-pointer-p ev) ; if the allocation was succesfull
       (chan ev 0)                  ; 0 means channel 1
       (port ev 0)                  ; set the destination port to 0
       (field ev 0 pitch)           ; set the pitch field
@@ -247,7 +247,7 @@
 (defun send-multiple-notes (n pitch delay)
   (let ((event (MidiNewEv typeNote))	; ask for a new note event
         (date (MidiGetTime)))		; remember the current time
-    (unless (cffi:null-ptr-p event)	; if the allocation was succesful
+    (unless (cffi:null-pointer-p event) ; if the allocation was succesful
       (chan event 0)			; 0 means channel 1
       (port event 0)			; set the destination port to 0
       (field event 0 pitch)		; set the pitch field
@@ -287,7 +287,7 @@
 
 (defun send-lyric (aString)
   (let ((event (MidiNewEv typeLyric)))
-    (unless (cffi:null-ptr-p event)
+    (unless (cffi:null-pointer-p event)
       (chan event 0)
       (port event 0)
       (text event aString)		
@@ -302,7 +302,7 @@
 
 (defun send-text (aType aString)
   (let ((event (MidiNewEv aType)))
-    (unless (cffi:null-ptr-p event)
+    (unless (cffi:null-pointer-p event)
       (chan event 0)
       (port event 0)
       (text event aString)		
@@ -321,7 +321,7 @@
 
 (defun send-smpte-offset (format hours minutes seconds frames subframes)
   (let ((event (MidiNewEv typeSMPTEOffset)))
-    (unless (cffi:null-ptr-p event)
+    (unless (cffi:null-pointer-p event)
       (chan event 0)
       (port event 0)
       (field event 0 format)		
@@ -351,7 +351,7 @@
   (MidiFlushEvs *refnum*)               ; flush old events in the rcv fifo
   (loop (if (eql stopkey t) (return))   ; loop until stopk pressed
       (do ((event (MidiGetEv *refnum*) (MidiGetEv *refnum*)))
-          ((cffi:null-ptr-p event))     ; in the rcv fifo
+          ((cffi:null-pointer-p event))     ; in the rcv fifo
         ;; note, keyOn and KeyOff events
         (if (member (evtype event) (list typeNote typeKeyOn typeKeyOff))
           (if (eql stopkey (pitch event))
@@ -378,7 +378,7 @@
 ;;   (defun midi-thru (refnum)
 ;;     (loop do
 ;;          (do ((event (MidiGetEv refnum) (MidiGetEv refnum)))
-;;              ((cffi:null-ptr-p event))
+;;              ((cffi:null-pointer-p event))
 ;;            (MidiSendIm refnum event))
 ;;          ))
 ;;   (MidiConnect *refnum* 0 -1)           ; connect MCL to MidiShare
@@ -471,7 +471,7 @@
 ;; (defun transpodelay (transpose delay)
 ;;   #'(lambda (refnum)
 ;;       (do ((event (MidiGetEv refnum) (MidiGetEv refnum)))
-;;           ((cffi:null-ptr-p event))
+;;           ((cffi:null-pointer-p event))
         
 ;;         (if (member (evtype event) (list typeNote typeKeyOn typeKeyOff))
 ;;           (progn
@@ -483,7 +483,7 @@
 ;; (defun echo (delay attenuation)
 ;;   #'(lambda (refnum)
 ;;       (do ((event (MidiGetEv refnum) (MidiGetEv refnum)))
-;;           ((cffi:null-ptr-p event))
+;;           ((cffi:null-pointer-p event))
         
 ;;         (when (or (and (= (evtype event) typeKeyOn) (> (vel event) 0))
 ;;                   (= (evtype event) typeNote))
@@ -491,7 +491,7 @@
 ;;                (vl (- (vel event) attenuation) (- vl attenuation))
 ;;                (note ))
 ;;               ((or (< vl 1)(> vl 127)))
-;;             (unless (cffi:null-ptr-p (setq note (MidiNewEv typeNote)))
+;;             (unless (cffi:null-pointer-p (setq note (MidiNewEv typeNote)))
 ;;               (port note (port event))
 ;;               (chan note (chan event))
 ;;               (pitch note (pitch event))
@@ -519,5 +519,5 @@
 ;;   `(loop 
 ;;      (process-wait "waiting events" #'waiting-events-tasks-p ,refnum)
 ;;      (do ((,event (MidiGetEv ,refnum) (MidiGetEv ,refnum)))	;read all the events
-;;          ((cffi:null-ptr-p ,event))
+;;          ((cffi:null-pointer-p ,event))
 ;;        ,@action)))
diff -u midishare.orig/player-test.lisp midishare/player-test.lisp
--- midishare.orig/player-test.lisp	2005-12-11 05:58:03.000000000 +0000
+++ midishare/player-test.lisp	2005-12-11 06:03:27.000000000 +0000
@@ -194,9 +194,9 @@
 ;; MidiShare
 
 (defun apply-seq (seq fun)
-  (unless (cffi:null-ptr-p seq)
+  (unless (cffi:null-pointer-p seq)
     (do ((ev (firstev seq) (link ev)))
-        ((cffi:null-ptr-p ev))
+        ((cffi:null-pointer-p ev))
       (funcall fun ev))))
 
 ;; Functions to print a Midi event in textual format
@@ -244,7 +244,7 @@
            "Undefined") )))
 
 (defun midi-string-ev (e &optional (f 4))
-  (unless (cffi:null-ptr-p e)
+  (unless (cffi:null-pointer-p e)
     (list 
     (format nil "~A ~3D/~4A ~A ~:a" 
                 (midi-string-date (date e)) 
@@ -285,7 +285,7 @@
 (defun add-track (seq tracknum pitch startdate)
   (dotimes (i 500)
     (let ((ev (MidiNewEv typeNote)))
-      (unless (cffi:null-ptr-p ev)
+      (unless (cffi:null-pointer-p ev)
         (MidiSetField ev 0 pitch)
         (MidiSetField ev 1 80)
         (MidiSetField ev 2 125)
@@ -310,7 +310,7 @@
   (let ((seq (MidiNewSeq)))
     (dotimes (i 50)
       (let ((ev (MidiNewEv typeNote)))
-        (unless (ccl:%null-ptr-p ev)
+        (unless (cffi:null-pointer-p ev)
           (MidiSetField ev 0 72)
           (MidiSetField ev 1 80)
           (MidiSetField ev 2 125)