? .DS_Store
? contrib/.DS_Store
? dom/.DS_Store
? dom/dom-builder.fas
? dom/dom-builder.fasl
? dom/dom-builder.lib
? dom/dom-impl.fas
? dom/dom-impl.fasl
? dom/dom-impl.lib
? dom/dom-sax.fas
? dom/dom-sax.fasl
? dom/dom-sax.lib
? dom/package.fas
? dom/package.fasl
? dom/package.lib
? runes/.DS_Store
? runes/characters.fas
? runes/characters.fasl
? runes/characters.lib
? runes/definline.fas
? runes/definline.fasl
? runes/definline.lib
? runes/encodings-data.fas
? runes/encodings-data.fasl
? runes/encodings-data.lib
? runes/encodings.fas
? runes/encodings.fasl
? runes/encodings.lib
? runes/package.fas
? runes/package.fasl
? runes/package.lib
? runes/syntax.fas
? runes/syntax.fasl
? runes/syntax.lib
? runes/xstream.fas
? runes/xstream.fasl
? runes/xstream.lib
? runes/ystream.fas
? runes/ystream.fasl
? runes/ystream.lib
? test/domtest.fas
? test/domtest.fasl
? test/domtest.lib
? test/xmlconf.fas
? test/xmlconf.fasl
? test/xmlconf.lib
? xml/catalog.fas
? xml/catalog.fasl
? xml/catalog.lib
? xml/characters.fas
? xml/characters.fasl
? xml/characters.lib
? xml/package.fas
? xml/package.fasl
? xml/package.lib
? xml/recoder.fas
? xml/recoder.fasl
? xml/recoder.lib
? xml/sax-handler.fas
? xml/sax-handler.fasl
? xml/sax-handler.lib
? xml/sax-proxy.fas
? xml/sax-proxy.fasl
? xml/sax-proxy.lib
? xml/space-normalizer.fas
? xml/space-normalizer.fasl
? xml/space-normalizer.lib
? xml/split-sequence.fas
? xml/split-sequence.fasl
? xml/split-sequence.lib
? xml/unparse.fas
? xml/unparse.fasl
? xml/unparse.lib
? xml/util.fas
? xml/util.fasl
? xml/util.lib
? xml/xml-name-rune-p.fas
? xml/xml-name-rune-p.fasl
? xml/xml-name-rune-p.lib
? xml/xml-parse.fas
? xml/xml-parse.fasl
? xml/xml-parse.lib
? xml/xmlns-normalizer.fas
? xml/xmlns-normalizer.fasl
? xml/xmlns-normalizer.lib
? xml/xmls-compat.fas
? xml/xmls-compat.fasl
? xml/xmls-compat.lib
Index: cxml.asd
===================================================================
RCS file: /project/cxml/cvsroot/cxml/cxml.asd,v
retrieving revision 1.11
diff -u -r1.11 cxml.asd
--- cxml.asd	24 Jan 2006 19:35:58 -0000	1.11
+++ cxml.asd	15 May 2006 20:46:00 -0000
@@ -73,7 +73,8 @@
      (:file "space-normalizer" :depends-on ("xml-parse"))
      (:file "catalog"         :depends-on ("xml-parse"))
      (:file "sax-proxy"       :depends-on ("xml-parse")))
-    :depends-on (:cxml-runes :puri :trivial-gray-streams))
+    :depends-on (:cxml-runes :puri
+			     #+(and clisp (not generic-streams)) :trivial-gray-streams))
 
 (defclass utf8dom-file (closure-source-file) ((of)))
 
Index: xml/package.lisp
===================================================================
RCS file: /project/cxml/cvsroot/cxml/xml/package.lisp,v
retrieving revision 1.11
diff -u -r1.11 package.lisp
--- xml/package.lisp	29 Dec 2005 00:31:36 -0000	1.11
+++ xml/package.lisp	15 May 2006 20:46:00 -0000
@@ -6,7 +6,9 @@
 (in-package :cl-user)
 
 (defpackage :cxml
-  (:use :cl :runes :runes-encoding :trivial-gray-streams)
+  (:use :cl :runes :runes-encoding
+	#-(and clisp (not generic-streams)) :gray
+	#+(and clisp (not generic-streams)) :trivial-gray-streams)
   (:export
    ;; xstreams
    #:make-xstream
Index: xml/xml-parse.lisp
===================================================================
RCS file: /project/cxml/cvsroot/cxml/xml/xml-parse.lisp,v
retrieving revision 1.60
diff -u -r1.60 xml-parse.lisp
--- xml/xml-parse.lisp	20 Mar 2006 12:42:26 -0000	1.60
+++ xml/xml-parse.lisp	15 May 2006 20:46:02 -0000
@@ -3050,7 +3050,8 @@
           (incf pos)))))
 
 (defmethod stream-read-sequence
-    ((stream octet-input-stream) sequence start end &key &allow-other-keys)
+    ((stream octet-input-stream) sequence
+     #+sbcl &optional start end #-sbcl &key #-sbcl &allow-other-keys)
   (with-slots (octets pos) stream
     (let* ((length (min (- end start) (- (length octets) pos)))
            (end1 (+ start length))
Index: xml/xmls-compat.lisp
===================================================================
RCS file: /project/cxml/cvsroot/cxml/xml/xmls-compat.lisp,v
retrieving revision 1.2
diff -u -r1.2 xmls-compat.lisp
--- xml/xmls-compat.lisp	28 Nov 2005 22:33:47 -0000	1.2
+++ xml/xmls-compat.lisp	15 May 2006 20:46:02 -0000
@@ -136,7 +136,9 @@
                      (compute-attributes node include-xmlns-attributes))
                     (lname (rod (node-name node)))
                     (ns (rod (node-ns node)))
-                    (qname (concatenate 'rod ns (rod ":") lname)))
+                    (qname (if (node-ns node)
+			       (concatenate 'rod ns (rod ":") lname)
+			       lname)))
                ;; fixme: namespaces
                (sax:start-element handler nil lname qname attlist)
                (dolist (child (node-children node))